'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _createStore = require('./createStore');

var _createStore2 = _interopRequireDefault(_createStore);

var _ = require('../');

var _transducersJs = require('transducers.js');

function reducer(state, _ref) {
  var type = _ref.type;
  var payload = _ref.payload;
  var todos = state.todos;

  switch (type) {
    case 'ADD_TODO':
      return _extends({}, state, {
        todos: [].concat(todos, [_extends({}, payload, {
          id: payload.id || state.idCounter
        })]),
        idCounter: state.idCounter + 1
      });
    case 'REMOVE_TODO':
      return _extends({}, state, { todos: todos.filter(function (t) {
          return t.id !== payload;
        }) });
    default:
      return state;
  }
}

describe('transducerProtocol()', function () {
  it('adds transducer protocol to store', function () {
    var store = _.transducerProtocol(_createStore2['default'])(reducer, { todos: [], idCounter: 1 });

    var actions = ['Use Redux', 'Weep with joy', 'Mutate inside the reducer', null, 'Learn about higher-order stores', { type: 'REMOVE_TODO', payload: 2 }, 'Learn about middleware'];

    _transducersJs.into(store, _transducersJs.compose(_transducersJs.keep(), _transducersJs.map(function (a) {
      return typeof a === 'string' ? { type: 'ADD_TODO', payload: { text: a } } : a;
    }), _transducersJs.filter(function (a) {
      return !(a.type === 'ADD_TODO' && /(M|m)utat(e|ion)/g.test(a.payload.text));
    })), actions);

    expect(store.getState()).to.deep.equal({
      todos: [{ id: 1, text: 'Use Redux' }, { id: 3, text: 'Learn about higher-order stores' }, { id: 4, text: 'Learn about middleware' }],
      idCounter: 5
    });
  });
});